<template>
  <div
    class="w-full aspect-[26/37] rounded-lg relative"
    @click="
      authenticated ? handleGameClick(gameForDisplay) : toggleLoginRegisterDialog()
    "
  >
    <div v-if="!isMultipleProvider" :class="['flex justify-center p-0 absolute w-full', !isMultipleProvider ? 'bottom-[1rem]' : 'bottom-[1.5rem]', 'z-[9]']">
      <img
        :src="gameForDisplay.ProviderLogoCenterPath"
        class="w-[65.8%] h-full object-contain"
        @error="(e) => e.target.remove()"
      />
    </div>
    <div v-else class="flex justify-center flex-col items-center absolute w-full z-[9] bottom-1 px-1">
      <img
        :src="gameForDisplay.ProviderLogoCenterPath"
        class="w-[65.8%] h-full object-contain"
        @error="(e) => e.target.remove()"
      />
      <span class="text-xs text-center font-bold fc-text4">{{
        gameForDisplay.GameNameForDisplay
      }}</span>
    </div>
    <div
      class="flex flex-col absolute w-8 h-[26.4px] left-2 top-2 items-start p-0 gap-1 z-[9]"
    >
      <div v-if="gameForDisplay.IsNewGame" class="w-8 h-[11.2px]">
        <img
          class="w-full h-full"
          :src="getAssetImage(`assets/theme/common/icon/new_icon.svg`)"
        />
      </div>
      <div v-if="gameForDisplay.IsHotGame" class="w-8 h-[11.2px]">
        <img
          class="w-full h-full"
          :src="getAssetImage(`assets/theme/common/icon/hot_icon.svg`)"
        />
      </div>
    </div>
    <div class="effect"></div>
    <div class="absolute h-full z-[7] border-[1px] border-[var(--border)] rounded-lg">
      <img
        :src="gameForDisplay.StarImagePath"
        class="w-full h-full object-contain"
        @error="
          (e) =>
            isHandleDefaultImageRender(gameForDisplay.StarImagePath)
              ? onErrorDefaultImage(e, gameForDisplay.StarImagePath)
              : e.target.remove()
        "
      />
    </div>
    <div class="absolute h-full w-full z-[4]">
      <img
        :src="
          getAssetImage(
            'assets/theme/new_black_theme/img_bg_entry_type_sports_h148.png'
          )
        "
        class="w-full h-full object-contain rounded-lg"
      />
    </div>
    <div
      class="box-border absolute inset-0 z-0 rounded-lg bg-background5"
    ></div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import SportDisplayModel from "../sport/sportDisplayModel";
import { store } from "@/store";
import { IGameBsi } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import { IGame } from "~~/models/IGetPlayableGamesResponse";

export default defineComponent({
  props: {
    game: {
      type: Object as PropType<IGameBsi>,
      required: true,
    },
    isMultipleProvider: {
      type: Boolean,
      required: true,
    },
  },
  setup(props) {
    const authenticated = computed(() => store.state.auth);
    const { getAssetImage, onErrorDefaultImage, isHandleDefaultImageRender, toggleLoginRegisterDialog } =
      commonHelper;
    const gameForDisplay = computed(() => new SportDisplayModel(props.game));
    const config = useRuntimeConfig();
    const router = useRouter();
    const route = useRoute();
    const handleGameClick = (game: IGame) => {
      const isDemo = config.public.CURRENTLY_ENV === "demo";
      const isWebId8 = store.state.webId === 8;
      const isSportPage = route.path.includes("/sports");
      const isMainTheme = store.state.selectedThemeName === "main";
      if (isDemo && isWebId8 && isSportPage && isMainTheme) {
        const location = EnumEntranceLocation.GameLobby;
        router.push(`/game/${game.GameId}?location=${location}&silent`);
      } else {
        handleGameEntryOpenWindow(game, 550, 850);
      }
    };
    return {
      authenticated,
      getAssetImage,
      gameForDisplay,
      handleGameEntryOpenWindow,
      onErrorDefaultImage,
      isHandleDefaultImageRender,
      handleGameClick,
      toggleLoginRegisterDialog,
    };
  },
});
</script>

<style scoped>
.effect {
  @apply absolute w-full h-[60%] bottom-0 z-[8];
  background: linear-gradient(180deg, rgba(5, 6, 30, 0) 0%, #05061e 71.35%);
  border-radius: 8px;
}
.card-border {
  background: var(--background5);
  border: 1px solid var(--border);
  border-radius: 8px;
}
body {
  background: var(--background1);
}
</style>
